# -----------------------------------------------------------------------------
# $Id: Grant.pm 869 2005-03-27 08:52:27Z topia $
# -----------------------------------------------------------------------------
package Channel::Mode::Oper::Grant;
use strict;
use warnings;
use base qw(Module);
use Mask;
use Multicast;
use Timer;

sub new {
    my $class = shift;
    my $this = $class->SUPER::new(@_);
    $this->{queue} = {}; # network name => [[channel(short),nick], ...]
    $this->{timer} = undef; # queueǤʤɬפˤʤTimer
    $this;
}

sub destruct {
    my ($this) = @_;
    if (defined $this->{timer}) {
	$this->{timer}->uninstall;
    }
}

sub message_arrived {
    my ($this,$msg,$sender) = @_;
    # ˿ʤिξ:
    # 1. СΥåǤ
    # 2. ޥɤJOINǤ
    # 3. ʬJOINǤϤʤ
    # 4. @դJOINǤϤʤ
    # 5. ΥͥǼʬ@äƤ
    # 6. mask˰פ
    if ($sender->isa('IrcIO::Server') &&
	$msg->command eq 'JOIN' &&
	defined $msg->nick &&
	$msg->nick ne RunLoop->shared->current_nick) {
	foreach (split /,/,$msg->param(0)) {
	    my ($ch_full,$mode) = (m/^(.+?)(?:\x07(.*))?$/);
	    my $ch_short = Multicast::detatch($ch_full);
	    my $ch = $sender->channel($ch_short);
	    my $myself = $ch->names($sender->current_nick);
	    if (defined $myself && $myself->has_o && (!defined $mode || $mode !~ /o/)) {
		if (Mask::match_deep_chan([$this->config->mask('all')],$msg->prefix,$ch_full)) {
		    # waitǻꤵ줿ÿηвˡ塼롣
		    # Ʊ˥塼òޡ롣
		    $this->push_to_queue($sender,$ch_short,$msg->nick);
		}
	    }
	}
    }
    $msg;
}

sub push_to_queue {
    my ($this,$server,$ch_short,$nick) = @_;
    my $wait = $this->config->wait || 0;
    if ($wait =~ /^\s*(\d+)\s*-\s*(\d+)\s*$/) {
	$wait = int(rand($2 - $1 + 1)) + $1;
    }
    Timer->new(
	After => $wait,
	Code => sub {
	    # оݤοͤ+oƤߡ
	    my $ch = $server->channel($ch_short);
	    return if !defined $ch;
	    my $target = $ch->names($nick);
	    return if !defined $target;
	    return if $target->has_o;

	    my $queue = $this->{queue}->{$server->network_name};
	    if (!defined $queue) {
		$queue = $this->{queue}->{$server->network_name} = [];
	    }
	    push @$queue,[$ch_short,$nick];
	    $this->prepare_timer;
	})->install;
}

sub prepare_timer {
    my ($this) = @_;
    # 塼òޡ¸ߤʤк
    if (!defined $this->{timer}) {
	$this->{timer} = Timer->new(
	    Interval => 0, # ǽtriggerѹ롣
	    Repeat => 1,
	    Code => sub {
		my ($timer) = @_;
		$timer->interval(1);

		# 3Ĥľò롣
		# ͥ˺磳ĤŻ롣
		foreach my $network_name (keys %{$this->{queue}}) {
		    my $queue = $this->{queue}->{$network_name};
		    my $server = $this->_runloop->network($network_name);
		    my $channels = {}; # ch_shortname => [nick,nick,...]
		    for (my $i = 0; @$queue && $i < 3; $i++) {
			my $elem = shift(@$queue);
			my $nicks = $channels->{$elem->[0]};
			if (!defined $nicks) {
			    $nicks = $channels->{$elem->[0]} = [];
			}
			push @$nicks,$elem->[1];
		    }
		    while (my ($ch_short,$nicks) = each %$channels) {
			$server->send_message(
			    $this->construct_irc_message(
				Command => 'MODE',
				Params => [$ch_short,
					   '+'.('o' x @$nicks),
					   @$nicks]));
		    }
		    # 塼ˤʤä饭Ⱦä
		    delete $this->{queue}->{$network_name} unless @$queue;
		}

		# ƤΥ塼ˤʤä齪λ
		if (!%{$this->{queue}}) {
		    $timer->uninstall;
		    $this->{timer} = undef;
		}
	    })->install;
    }
}

1;

=pod
info: Υͥοʹ֤joinˡʬͥ륪ڥ졼¤äƤ+o롣
default: off
section: important

# splitʤɤ+oоݤοͤ٤̤äƤ+oϾļ¹Ԥޤ
# Excess FloodˤϤʤʤȦǤܳŪɱBOT˻ȤʪǤϤޤ

# оݤοʹ֤joinƤºݤ+oޤǲԤĤ
# ά줿Ԥޤ
# 5-10 Τ褦˻ꤵȡͤǥԤޤ
wait: 2-5

# ͥȿʹ֤ΥޥAuto::OperƱ͡
-mask: * example!~example@*.example.ne.jp
=cut
