# -*- cperl -*-
# -----------------------------------------------------------------------------
# $Id: RawLog.pm 822 2005-03-07 18:05:42Z topia $
# -----------------------------------------------------------------------------
# copyright (C) 2003 Topia <topia@clovery.jp>. all rights reserved.

package Debug::RawLog;
use strict;
use warnings;
use base qw(Module);
use Module::Use qw(Tools::DateConvert);
use Tools::DateConvert;
use Mask;
use Multicast;

sub message_io_hook {
    my ($this,$message,$io,$type) = @_;

    my $prefix = 'RAWLOG: ';
    my $conf_entry = 'enable-';

    $prefix .= do {
	if ($type eq 'in') {
	    '<<';
	} elsif ($type eq 'out') {
	    '>>';
	} else {
	    '--';
	}
    };

    $prefix .= do {
	if ($io->server_p()) {
	    'SERVER(' . $io->network_name() . ') ';
	} elsif ($io->client_p()) {
	    'CLIENT(' . ($io->option('logname') || $io->fullname()) . ') ';
	} else {
	    '------ ';
	}
    };

    $conf_entry .= do {
	if ($io->server_p()) {
	    'server'
	} elsif ($io->client_p()) {
	    'client';
	}
    };

    $conf_entry .= '-' . $type;

    # break with last
    while (1) {
	last if (($message->command =~ /^P[IO]NG$/) &&
		     $this->config->ignore_ping);
	last unless ($this->config->get($conf_entry));
	my $msg = $message->clone;
	if ($this->config->resolve_numeric && $message->command =~ /^\d{3}$/) {
	    $msg->command(
		(NumericReply::fetch_name($message->command)||'undef').
		    '('.$message->command.')');
	}
	::printmsg($prefix . $msg->serialize());
	last;
    }

    return $message;
}

1;

=pod
info: ɸϤ˥饤Ȥ䥵ФȤ̿פ롣
default: off

# 0 ޤϾάɽʤ 1 ɽ롣
# 饤ȥץ logname ˤäơפ˻Ȥ̾Ǥޤ

# Ф
enable-server-in: 1

# Фؤν
enable-server-out: 1

# 饤Ȥ
enable-client-in: 0

# 饤Ȥؤν
enable-client-out: 0

# PING/PONG ̵뤹
ignore-ping: 1

# NumericReply ̾褷ɽ(Ȥ dump Ǥ̵ʤޤ)
resolve-numeric: 1
=cut
